//********************************************************************
//  QuoteGUI2.java       Author: Lewis/Loftus
//
//  Solution to Programming Project 6.12 (5E, p. 368)
//********************************************************************

import javax.swing.*;
import java.awt.*;
import javax.swing.border.LineBorder;
import java.awt.event.*;

public class QuoteGUI2
{
   private final int WIDTH = 400, HEIGHT = 100;
   private JPanel primary;
   private JLabel quote;
   private JRadioButton comedy, philosophy, carpentry;
   private String comedyQuote = "Take my wife, please.";
   private String philosophyQuote = "I think, therefore I am.";
   private String carpentryQuote = "Measure twice. Cut once.";

   //-----------------------------------------------------------------
   //  Sets up a panel with a label and a set of radio buttons
   //  that control its text.
   //-----------------------------------------------------------------
   public QuoteGUI2()
   {
      quote = new JLabel (comedyQuote);
      quote.setFont (new Font ("Helvetica", Font.BOLD, 24));

      comedy = new JRadioButton ("Comedy", true);
      comedy.setBackground (Color.green);
      philosophy = new JRadioButton ("Philosophy");
      philosophy.setBackground (Color.green);
      carpentry = new JRadioButton ("Carpentry");
      carpentry.setBackground (Color.green);

      ButtonGroup group = new ButtonGroup();
      group.add (comedy);
      group.add (philosophy);
      group.add (carpentry);
      
      // create a panel for the radio buttons
      JPanel buttonPanel = new JPanel ();
      buttonPanel.setLayout (new BoxLayout(buttonPanel, BoxLayout.Y_AXIS));
      buttonPanel.setBorder (new LineBorder(Color.black, 3));
      buttonPanel.setBackground (Color.green);

      buttonPanel.add (comedy);
      buttonPanel.add (philosophy);
      buttonPanel.add (carpentry);
      
      QuoteListener listener = new QuoteListener();
      comedy.addActionListener (listener);
      philosophy.addActionListener (listener);
      carpentry.addActionListener (listener);

      primary = new JPanel();
      primary.setLayout(new BorderLayout());
      primary.add (quote, BorderLayout.CENTER);
      primary.add (buttonPanel, BorderLayout.WEST);
      
      primary.setBackground (Color.green);
      primary.setPreferredSize (new Dimension(WIDTH, HEIGHT));
   }

   //-----------------------------------------------------------------
   //  Returns the primary panel containing the GUI.
   //-----------------------------------------------------------------
   public JPanel getPanel()
   {
      return primary;
   }

   //*****************************************************************
   //  Represents the listener for all radio buttons
   //*****************************************************************
   private class QuoteListener implements ActionListener
   {
      //--------------------------------------------------------------
      //  Sets the text of the label depending on which radio
      //  button was pressed.
      //--------------------------------------------------------------
      public void actionPerformed (ActionEvent event)
      {
         Object source = event.getSource();

         if (source == comedy)
            quote.setText (comedyQuote);
         else
            if (source == philosophy)
               quote.setText (philosophyQuote);
            else
               quote.setText (carpentryQuote);
      }
   }
}
